Code

8c5da7219e760cd7e57b523eb626629727b1d44b
[git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
6 USAGE='[--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name.  When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic.  You will have to resolve any such merge failure
15 and run git rebase --continue.  Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip.  To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.  You must be in the top
22 directory of your project to start (or continue) a rebase.
24 Example:       git-rebase master~1 topic
26         A---B---C topic                   A'\''--B'\''--C'\'' topic
27        /                   -->           /
28   D---E---F---G master          D---E---F---G master
29 '
30 . git-sh-setup
32 RESOLVEMSG="
33 When you have resolved this problem run \"git rebase --continue\".
34 If you would prefer to skip this patch, instead run \"git rebase --skip\".
35 To restore the original branch and stop rebasing run \"git rebase --abort\".
36 "
37 unset newbase
38 case "${GIT_USE_RECUR_FOR_RECURSIVE}" in
39 '')
40         strategy=recursive ;;
41 ?*)
42         strategy=recur ;;
43 esac
45 do_merge=
46 dotest=$GIT_DIR/.dotest-merge
47 prec=4
49 continue_merge () {
50         test -n "$prev_head" || die "prev_head must be defined"
51         test -d "$dotest" || die "$dotest directory does not exist"
53         unmerged=$(git-ls-files -u)
54         if test -n "$unmerged"
55         then
56                 echo "You still have unmerged paths in your index"
57                 echo "did you forget update-index?"
58                 die "$RESOLVEMSG"
59         fi
61         if test -n "`git-diff-index HEAD`"
62         then
63                 if ! git-commit -C "`cat $dotest/current`"
64                 then
65                         echo "Commit failed, please do not call \"git commit\""
66                         echo "directly, but instead do one of the following: "
67                         die "$RESOLVEMSG"
68                 fi
69                 printf "Committed: %0${prec}d" $msgnum
70         else
71                 printf "Already applied: %0${prec}d" $msgnum
72         fi
73         echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
74                                 sed 's/^[a-f0-9]\+ //'`
76         prev_head=`git-rev-parse HEAD^0`
77         # save the resulting commit so we can read-tree on it later
78         echo "$prev_head" > "$dotest/prev_head"
80         # onto the next patch:
81         msgnum=$(($msgnum + 1))
82         echo "$msgnum" >"$dotest/msgnum"
83 }
85 call_merge () {
86         cmt="$(cat $dotest/cmt.$1)"
87         echo "$cmt" > "$dotest/current"
88         git-merge-$strategy "$cmt^" -- HEAD "$cmt"
89         rv=$?
90         case "$rv" in
91         0)
92                 return
93                 ;;
94         1)
95                 test -d "$GIT_DIR/rr-cache" && git-rerere
96                 die "$RESOLVEMSG"
97                 ;;
98         2)
99                 echo "Strategy: $rv $strategy failed, try another" 1>&2
100                 die "$RESOLVEMSG"
101                 ;;
102         *)
103                 die "Unknown exit code ($rv) from command:" \
104                         "git-merge-$strategy $cmt^ -- HEAD $cmt"
105                 ;;
106         esac
109 finish_rb_merge () {
110         rm -r "$dotest"
111         echo "All done."
114 while case "$#" in 0) break ;; esac
115 do
116         case "$1" in
117         --continue)
118                 diff=$(git-diff-files)
119                 case "$diff" in
120                 ?*)     echo "You must edit all merge conflicts and then"
121                         echo "mark them as resolved using git update-index"
122                         exit 1
123                         ;;
124                 esac
125                 if test -d "$dotest"
126                 then
127                         prev_head="`cat $dotest/prev_head`"
128                         end="`cat $dotest/end`"
129                         msgnum="`cat $dotest/msgnum`"
130                         onto="`cat $dotest/onto`"
131                         continue_merge
132                         while test "$msgnum" -le "$end"
133                         do
134                                 call_merge "$msgnum"
135                                 continue_merge
136                         done
137                         finish_rb_merge
138                         exit
139                 fi
140                 git am --resolved --3way --resolvemsg="$RESOLVEMSG"
141                 exit
142                 ;;
143         --skip)
144                 if test -d "$dotest"
145                 then
146                         prev_head="`cat $dotest/prev_head`"
147                         end="`cat $dotest/end`"
148                         msgnum="`cat $dotest/msgnum`"
149                         msgnum=$(($msgnum + 1))
150                         onto="`cat $dotest/onto`"
151                         while test "$msgnum" -le "$end"
152                         do
153                                 call_merge "$msgnum"
154                                 continue_merge
155                         done
156                         finish_rb_merge
157                         exit
158                 fi
159                 git am -3 --skip --resolvemsg="$RESOLVEMSG"
160                 exit
161                 ;;
162         --abort)
163                 if test -d "$dotest"
164                 then
165                         rm -r "$dotest"
166                 elif test -d .dotest
167                 then
168                         rm -r .dotest
169                 else
170                         die "No rebase in progress?"
171                 fi
172                 git reset --hard ORIG_HEAD
173                 exit
174                 ;;
175         --onto)
176                 test 2 -le "$#" || usage
177                 newbase="$2"
178                 shift
179                 ;;
180         -M|-m|--m|--me|--mer|--merg|--merge)
181                 do_merge=t
182                 ;;
183         -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
184                 --strateg=*|--strategy=*|\
185         -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
186                 case "$#,$1" in
187                 *,*=*)
188                         strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
189                 1,*)
190                         usage ;;
191                 *)
192                         strategy="$2"
193                         shift ;;
194                 esac
195                 do_merge=t
196                 ;;
197         -*)
198                 usage
199                 ;;
200         *)
201                 break
202                 ;;
203         esac
204         shift
205 done
207 case "$strategy,${GIT_USE_RECUR_FOR_RECURSIVE}" in
208 recursive,?*)
209         strategy=recur ;;
210 esac
212 # Make sure we do not have .dotest
213 if test -z "$do_merge"
214 then
215         if mkdir .dotest
216         then
217                 rmdir .dotest
218         else
219                 echo >&2 '
220 It seems that I cannot create a .dotest directory, and I wonder if you
221 are in the middle of patch application or another rebase.  If that is not
222 the case, please rm -fr .dotest and run me again.  I am stopping in case
223 you still have something valuable there.'
224                 exit 1
225         fi
226 else
227         if test -d "$dotest"
228         then
229                 die "previous dotest directory $dotest still exists." \
230                         'try git-rebase < --continue | --abort >'
231         fi
232 fi
234 # The tree must be really really clean.
235 git-update-index --refresh || exit
236 diff=$(git-diff-index --cached --name-status -r HEAD)
237 case "$diff" in
238 ?*)     echo "$diff"
239         exit 1
240         ;;
241 esac
243 # The upstream head must be given.  Make sure it is valid.
244 upstream_name="$1"
245 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
246     die "invalid upstream $upstream_name"
248 # If a hook exists, give it a chance to interrupt
249 if test -x "$GIT_DIR/hooks/pre-rebase"
250 then
251         "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
252                 echo >&2 "The pre-rebase hook refused to rebase."
253                 exit 1
254         }
255 fi
257 # If the branch to rebase is given, first switch to it.
258 case "$#" in
259 2)
260         branch_name="$2"
261         git-checkout "$2" || usage
262         ;;
263 *)
264         branch_name=`git symbolic-ref HEAD` || die "No current branch"
265         branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
266         ;;
267 esac
268 branch=$(git-rev-parse --verify "${branch_name}^0") || exit
270 # Make sure the branch to rebase onto is valid.
271 onto_name=${newbase-"$upstream_name"}
272 onto=$(git-rev-parse --verify "${onto_name}^0") || exit
274 # Now we are rebasing commits $upstream..$branch on top of $onto
276 # Check if we are already based on $onto, but this should be
277 # done only when upstream and onto are the same.
278 if test "$upstream" = "$onto"
279 then
280         mb=$(git-merge-base "$onto" "$branch")
281         if test "$mb" = "$onto"
282         then
283                 echo >&2 "Current branch $branch_name is up to date."
284                 exit 0
285         fi
286 fi
288 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
289 git-reset --hard "$onto"
291 # If the $onto is a proper descendant of the tip of the branch, then
292 # we just fast forwarded.
293 if test "$mb" = "$onto"
294 then
295         echo >&2 "Fast-forwarded $branch to $newbase."
296         exit 0
297 fi
299 if test -z "$do_merge"
300 then
301         git-format-patch -k --stdout --full-index "$upstream"..ORIG_HEAD |
302         git am --binary -3 -k --resolvemsg="$RESOLVEMSG"
303         exit $?
304 fi
306 if test "@@NO_PYTHON@@" && test "$strategy" = "recursive"
307 then
308         die 'The recursive merge strategy currently relies on Python,
309 which this installation of git was not configured with.  Please consider
310 a different merge strategy (e.g. octopus, resolve, stupid, ours)
311 or install Python and git with Python support.'
313 fi
315 # start doing a rebase with git-merge
316 # this is rename-aware if the recursive (default) strategy is used
318 mkdir -p "$dotest"
319 echo "$onto" > "$dotest/onto"
320 prev_head=`git-rev-parse HEAD^0`
321 echo "$prev_head" > "$dotest/prev_head"
323 msgnum=0
324 for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
325                         | @@PERL@@ -e 'print reverse <>'`
326 do
327         msgnum=$(($msgnum + 1))
328         echo "$cmt" > "$dotest/cmt.$msgnum"
329 done
331 echo 1 >"$dotest/msgnum"
332 echo $msgnum >"$dotest/end"
334 end=$msgnum
335 msgnum=1
337 while test "$msgnum" -le "$end"
338 do
339         call_merge "$msgnum"
340         continue_merge
341 done
343 finish_rb_merge